library ptwebserver;

import 'dart:io';
import 'config.dart';

class ptWebServer {
  ptConfig config;
  
  ptWebServer({String configFile,ptConfig this.config}) {
    
  }
  
  void Run() {
    print("Starting ${config.servername}");
    Map hosts = new Map();
    
    for(int i=0; i<config.hosts.length; ++i) {
      ptHost host = config.hosts[i];
      
      if(!hosts.containsKey(host.address)) {
        hosts[host.address]=new Map();
      }
      
      Map cHost = hosts[host.address];
      
      if(cHost.containsKey(host.port)) {
        cHost[host.port] = new List<ptHost>(); 
      }
      
      List<ptHost> cPort = cHost[host.port];
      cPort.add(host);
    }
    
    hosts.forEach((String addr, Map ports) {
      ports.forEach((int port,List<ptHost> col) {
        StartListener(addr,port,col);
      });
    });
  }
  
  void StartListener(String address,int port, List<ptHost> hosts) {
    print("Binding to ${address}:${port}");
    
    HttpServer.bind(address,port).then((server) {
      
      print("Listening to ${address}:${port}");
      
      server.listen((HttpRequest request) {
        HttpHeaders headers = request.headers;
        HttpResponse response = request.response;
        headers.forEach((name,List<String> value) {
          for(int i=0; i<value.length; ++i)
            response.write("${name} ${value[i]}\r\n");
        });
      });
    });
  }
  
}